/*
 * Center.java - Simple lpexlet
 *
 * Notes:
 *   1.- compile it with:
 *         javac Center.java
 *   2.- ensure that the resulting Center.class is in the CLASSPATH
 *   3.- start the editor:
 *         codeedit
 *   4.- invoke lpexlet Center from the LPEX command line with the cursor on
 *       the source line to be centered:
 *         java Center
 *   Note: you can specify a numeric parameter which is used instead of the
 *         TEXTLIMIT as the length to center the text in
 */

/******************************************************************************/
/* The lpexlet is Center.  It subclasses LpexCommand, the LPEX JPI.             */
/******************************************************************************/
public class Center extends LpexCommand
{

   /*=========================================================================*/
   /*  lpexEntry() - main entry point from LPEX.  Overrides LpexCommand's.    */
   /*=========================================================================*/
   public static int lpexEntry (String arg)
   {
      int parm = 2500;
      // if arg specified, try and interpret it as the length to center the text in
      if (arg.length() != 0)
      {
        try {
          parm = Integer.parseInt(arg);
          if ( parm < 1 )
            parm = 2500;
        }
	     catch (NumberFormatException e) {
  	       parm = 2500;
        }
      }

      // get the text, it's length, and the file's text limit
      String text = lpexGetText().trim();
      int textlength = text.length();
      int textlimit = lpexGetIntParm("TEXTLIMIT");

      // if parm is specified and less then the file's text limit, use it
      if ( parm < textlimit )
        textlimit = parm;

      // center the text
      if ( textlength < textlimit )
      {
        int spaces = (textlimit - textlength) / 2;
        if ( spaces > 0 )
        {
          String blanks = "                                                                      ";
          if ( spaces < blanks.length() )
          {
            String newtext = blanks.substring(1,spaces + 1).concat(text);
            lpexSetText(newtext);
          }
        }
      }  // end if text length < text limit

      // return a good return code to LPEX
      return 0;
   }

}
