/*
 * ToolbarFrame.java - Simple lpexlet
 *
 * Notes:
 *   1.- compile it with:
 *         javac ToolbarFrame.java
 *   2.- ensure that the resulting ToolbarFrame.class is in the CLASSPATH
 *   3.- ensure that Toolbar.class is in the CLASSPATH
 *   4.- start the editor:
 *         codeedit
 *   5.- invoke lpexlet Toolbar from the LPEX command line
 *         java Toolbar
 *   Note: this requires the Toolbar class
 */

import java.awt.*;
import java.awt.event.*;
import Toolbar;

class ToolbarFrame extends Frame implements ActionListener
{
   Button btnNew    = new Button("New");
   Button btnOpen   = new Button("Open");
   Button btnGet    = new Button("Get");
   Button btnSave   = new Button("Save");
   Button btnSaveAs = new Button("Save as");
   Button btnFind   = new Button("Find");

   ToolbarFrame ()
   {
      // give toolbar frame a title, a buttons layout, and some colour
      super("LPEXtra Toolbar");
      setLayout(new FlowLayout());
      setBackground(Color.lightGray);

      // make mouse pointer show a hand when over the buttons
      Cursor btnCursor = Cursor.getPredefinedCursor(Cursor.HAND_CURSOR);
      btnNew.setCursor(btnCursor);
      btnOpen.setCursor(btnCursor);
      btnGet.setCursor(btnCursor);
      btnSave.setCursor(btnCursor);
      btnSaveAs.setCursor(btnCursor);
      btnFind.setCursor(btnCursor);

      // add the buttons to the toolbar frame
      add(btnNew);
      add(btnOpen);
      add(btnGet);
      add(btnSave);
      add(btnSaveAs);
      add(btnFind);

      // & their "pushbutton" action listeners
      btnFind.addActionListener(this);
      btnSaveAs.addActionListener(this);
      btnSave.addActionListener(this);
      btnGet.addActionListener(this);
      btnOpen.addActionListener(this);
      btnNew.addActionListener(this);

      // listen to the toolbar window being asked to close (Alt+F4)
      this.addWindowListener(new WindowEventHandler());

      // size toolbar optimally, display it
      pack();
      show();
      toFront();
   }

   public void actionPerformed (ActionEvent evt)
   {
      if (evt.getSource()      == btnOpen)
          Toolbar.doOpen();
      else if (evt.getSource() == btnSave)
          Toolbar.doSave();
      else if (evt.getSource() == btnSaveAs)
          Toolbar.doSaveAs();
      else if (evt.getSource() == btnNew)
          Toolbar.doNew();
      else if (evt.getSource() == btnGet)
          Toolbar.doGet();
      else if (evt.getSource() == btnFind)
          Toolbar.doFind();
   }

   class WindowEventHandler extends WindowAdapter
   {
      public void windowClosing (WindowEvent evt)
      {
         dispose();
      }
   }
}
